///////////////////////////////////////////////////////////////////////////////
//
//	File:		DrawingFunctions.h
//
//	Project:	MacHack 2000 - Vertigo!
//	Authors:	Darrin Cardani, Drew Thaler, Ed Wynne
//
//	Date:		06/23/2000 (written entirely during the conference!)
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _H_DrawingFunctions
#define _H_DrawingFunctions

#include <Quickdraw.h>
#include <QDOffscreen.h>

#include "DrawingUtils.h"


#ifdef __cplusplus
extern "C" {
#endif

// Renders drop shadows into a scratch GWorld.  
void RenderDropShadows(const GWorldPtr screenGWorld,
						GWorldPtr dropShadowWorld, 
						RgnHandle maskRgn,
						RegionList &windowRegions);

// Copies a region from the drop-shadow world into another scratch GWorld, and
//	fills the region border with white.
void CopyRegionForRedShifting(const GWorldPtr dropShadowWorld,
								GWorldPtr preShiftWorld,
								RgnHandle rgn);

// Does a red-shift and blur into yet another scratch GWorld.
void RedShiftAndBlur(const GWorldPtr preShiftWorld,
						GWorldPtr scratchWorld,
						GWorldPtr postShiftWorld,
						RgnHandle rgn,
						int shift);

void RedShiftAndBlurRect(const GWorldPtr preShiftWorld,
						GWorldPtr scratchWorld,
						GWorldPtr postShiftWorld,
						const Rect *rect,
						int shift);

// Copies the drop shadowed, shifted, blurred, output into the composite.
void CopyIntoComposite(const GWorldPtr srcWorld,
						GWorldPtr compositeWorld,
						RgnHandle rgn);

#ifdef __cplusplus
}
#endif


#endif // _H_DrawingFunctions
